#include <mpi.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <iostream>

int main(int argc, char** argv){
  int rank;
  int P;
  int tag=50;
  int dims[2] = {0,0};
  int periods[2] = {0,0};
  int coords[2] = {0,0};
  MPI_Comm comm_grid;
  char hostname[256];
  MPI_Status status;  

  MPI_Init(&argc, &argv);

  MPI_Comm_rank(MPI_COMM_WORLD, &rank);
  MPI_Comm_size(MPI_COMM_WORLD, &P);

  MPI_Dims_create(P, 2, dims);
  MPI_Cart_create(MPI_COMM_WORLD, 2, dims, periods, 0, &comm_grid);
    
  gethostname(hostname,255);
  
  std::cout << "rank: " << rank << " " << hostname << std::endl;
  
  MPI_Barrier(comm_grid);
  if(rank==0){
    for(int i=0; i<dims[0]; ++i)
      {
	for(int j=0; j<dims[1]; ++j)
	  {
	    int r;
	    int c[2] = {i,j};

	    MPI_Cart_rank(comm_grid, c, &r);
	    std:: cout << r << "\t";
	  }
	std::cout << std::endl;
      }
  }
  MPI_Barrier(comm_grid);

  int left=0, right=0;
  MPI_Cart_shift(comm_grid, 1, 1, &left, &right);
  
  MPI_Send(hostname,strlen(hostname)+1,MPI_CHAR,right,tag,comm_grid);
  MPI_Recv(hostname,256,MPI_CHAR,left,tag,comm_grid,&status);

  std::cout << "rank: " << rank << " von links: " << hostname << std::endl;  
  
  MPI_Finalize();
}
